package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.DrugBillNeoDTO;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.entity.node.*;
import com.diagbot.util.NeoUtil;
import com.diagbot.vo.Drug;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;


public class MedRegNameNode {

    /**
     * 获取高危药品数据
     */
    public List<HighRiskNeoDTO> getHighRiskDrug(List<Drug> druglist, MedicineRepository medRepository,
                                                MedicineCodeRepository medCodeRepository) {
        List<HighRiskNeoDTO> highRiskNeoDTOS = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO;
        String drugname, drugform;
        List<Medicine> medicine;
        List<MedCodeName> medcdnames;
        MedRegName medreg;

        for (Drug drug : druglist) {
            highRiskNeoDTO = new HighRiskNeoDTO();

            drugname = drug.getUniqueName();
            highRiskNeoDTO.setName(drug.getName());
            highRiskNeoDTO.setStandname(drugname);
            drugform = drug.getForm();

            medicine = medRepository.findByNameIs(drugname);

            if (null != medicine) {
                for (Medicine med: medicine) {
                    for (MedCodeName medcdname : med.getMedcodenames()) {
                        if (medcdname.getReg_JiXin().equals(drugform)) {
                            medcdnames = medCodeRepository.findByNameIs(medcdname.getName());
                            for (MedCodeName medcdnm : medcdnames) {
                                List<MedRegName> medRegNames = new ArrayList<>(medcdnm.getMedregnames());
                                medreg = medRegNames.get(0);
                                if (null != medreg.getRisklevel() && medreg.getRisklevel().trim().length() > 0) {
                                    highRiskNeoDTO.setIsHighrisk(true);
                                    highRiskNeoDTO.setHighLevel(medreg.getRisklevel());
                                    highRiskNeoDTO.setType(Constants.yaoping);
                                    highRiskNeoDTO.setForm(drugform);
                                    highRiskNeoDTOS.add(highRiskNeoDTO);
                                    break;
                                }
                            }

                            if (highRiskNeoDTO.getType()!=null) {
                                break;
                            }
                        }
                    }

                    if (highRiskNeoDTO.getType()!=null) {
                        break;
                    }

                }
            }
        }

        return highRiskNeoDTOS;
    }


    public DrugBillNeoDTO MedRegNametoDrugDTO(MedRegName medRegName, DrugBillNeoDTO drugBillNeoDTO) {

        Set<Age> ages = medRegName.getAge();
        for (Age age : ages) {
            NodeNeoDTO nodeNeoDTO = NeoUtil.fillNodeNeoDTO(age);
            drugBillNeoDTO.setAgeNeoDTO(nodeNeoDTO);
        }

        Set<Group> groups = medRegName.getGroup();
        for (Group group : groups) {
            NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();
            nodeNeoDTO.setName(group.getName());
            nodeNeoDTO.setTermtype(Constants.group);
            drugBillNeoDTO.getGroup().add(nodeNeoDTO);
        }


        Set<MedAllergen> medAllergens = medRegName.getMedAllergens();
        for (MedAllergen medAllergen : medAllergens) {
            NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();
            nodeNeoDTO.setName(medAllergen.getName());
            nodeNeoDTO.setTermtype(Constants.yaoping);
            drugBillNeoDTO.getAllergicmeds().add(nodeNeoDTO);
        }


        String conflict_gender = medRegName.getConflict_gender();
        if (null!=conflict_gender) {
            NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();
            nodeNeoDTO.setName(conflict_gender);
            nodeNeoDTO.setTermtype(Constants.gender);
            drugBillNeoDTO.setGender(nodeNeoDTO);
        }


        String conflict_geiyao = medRegName.getConflict_geiyao();
        if (null!=conflict_geiyao) {
            NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();
            nodeNeoDTO.setName(conflict_geiyao);
            nodeNeoDTO.setTermtype(Constants.geiyao);
            drugBillNeoDTO.setGeiyaoNeoDTO(nodeNeoDTO);
        }


        return drugBillNeoDTO;
    }
}

